/*
APPENDIX C
"compress.c":  Test program for entropy coding: compresses a file
using a one-byte data model.
*/
#include <stdio.h>
#include "elscoder.h"

rung_t Context[256];

int main(int argc,char *argv[])
	{
	FILE	*in_file,*out_file;
	int		buffer,index;

	if (argc!=3)
		{
		fprintf(stderr,"Usage:\n\n~compress <in_file> <out_file>\n\n"
		 "Tests entropy coder with 1-byte-context file encoding.\n");
		return 1;
		}

	if (!(in_file = fopen(argv[1],"rb")))
		{
		printf("Unable to open input file.\n");
		return 1;
		}
	if (!(out_file = fopen(argv[2],"wb")))
		{
		printf("Unable to open output file.\n");
		return 1;
		}

	/*
	 @	Initialize probabilities of state machine.
	 */
	for (index=0; index<256; index++)
		Context[index] = 0;

	encode_start(out_file);
	while((buffer = fgetc(in_file)) != EOF)
		{
		index = 1;
		encode_bit(Context+index,buffer&0x80);
		index = (index<<1) | !!(buffer&0x80);
		encode_bit(Context+index,buffer&0x40);
		index = (index<<1) | !!(buffer&0x40);
		encode_bit(Context+index,buffer&0x20);
		index = (index<<1) | !!(buffer&0x20);
		encode_bit(Context+index,buffer&0x10);
		index = (index<<1) | !!(buffer&0x10);
		encode_bit(Context+index,buffer&0x08);
		index = (index<<1) | !!(buffer&0x08);
		encode_bit(Context+index,buffer&0x04);
		index = (index<<1) | !!(buffer&0x04);
		encode_bit(Context+index,buffer&0x02);
		index = (index<<1) | !!(buffer&0x02);
		encode_bit(Context+index,buffer&0x01);
		index = (index<<1) | !!(buffer&0x01);
		if (buffer==255)
			{
			/* Send 0 to distinguish from EOF marker. */
			encode_bit(Context,0);
			}
		}
	/* Send 255 followed by 1 for EOF marker. */
	encode_bit(Context+1,1);
	encode_bit(Context+3,1);
	encode_bit(Context+7,1);
	encode_bit(Context+15,1);
	encode_bit(Context+31,1);
	encode_bit(Context+63,1);
	encode_bit(Context+127,1);
	encode_bit(Context+255,1);
	encode_bit(Context,1);

	encode_end();
	fclose(out_file);
	fclose(in_file);

	return 0;
	}
