/*
APPENDIX B
"elscoder.c":  data and procedures for ELS-coder.
*/

#define ALACRITOUS
#include "elscoder.h"

typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned long ulong;

#define F 754

static ushort A[2*F] = {
     1,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
 	 2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
	 2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
	 2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
	 2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
	 2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
	 2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
	 2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,    3,
     3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
     3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
     3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
     3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
     3,    3,    3,    3,    3,    3,    4,    4,    4,    4,    4,    4,
	 4,    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
	 4,    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
     4,    4,    4,    4,    4,    4,    4,    4,    4,    5,    5,    5,
	 5,    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
     5,    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
     5,    5,    5,    6,    6,    6,    6,    6,    6,    6,    6,    6,
	 6,    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
	 6,    6,    6,    6,    7,    7,    7,    7,    7,    7,    7,    7,
     7,    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
	 7,    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
     8,    8,    8,    8,    8,    8,    8,    9,    9,    9,    9,    9,
     9,    9,    9,    9,    9,    9,    9,    9,    9,    9,    9,   10,
    10,   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
	10,   10,   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
    11,   11,   11,   12,   12,   12,   12,   12,   12,   12,   12,   12,
    12,   12,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
    13,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   15,
    15,   15,   15,   15,   15,   15,   15,   15,   15,   16,   16,   16,
    16,   16,   16,   16,   16,   16,   17,   17,   17,   17,   17,   17,
    17,   17,   18,   18,   18,   18,   18,   18,   18,   18,   19,   19,
    19,   19,   19,   19,   19,   20,   20,   20,   20,   20,   20,   20,
	21,   21,   21,   21,   21,   21,   22,   22,   22,   22,   22,   22,
    22,   23,   23,   23,   23,   23,   23,   24,   24,   24,   24,   24,
	24,   25,   25,   25,   25,   25,   26,   26,   26,   26,   26,   26,
    27,   27,   27,   27,   27,   28,   28,   28,   28,   28,   29,   29,
    29,   29,   30,   30,   30,   30,   30,   31,   31,   31,   31,   32,
	32,   32,   32,   32,   33,   33,   33,   33,   34,   34,   34,   34,
    35,   35,   35,   35,   36,   36,   36,   36,   37,   37,   37,   38,
    38,   38,   38,   39,   39,   39,   39,   40,   40,   40,   41,   41,
	41,   42,   42,   42,   42,   43,   43,   43,   44,   44,   44,   45,
    45,   45,   46,   46,   46,   47,   47,   47,   48,   48,   48,   49,
    49,   49,   50,   50,   51,   51,   51,   52,   52,   52,   53,   53,
    54,   54,   54,   55,   55,   56,   56,   56,   57,   57,   58,   58,
	58,   59,   59,   60,   60,   61,   61,   62,   62,   62,   63,   63,
    64,   64,   65,   65,   66,   66,   67,   67,   68,   68,   69,   69,
    70,   70,   71,   71,   72,   72,   73,   73,   74,   74,   75,   75,
    76,   77,   77,   78,   78,   79,   79,   80,   81,   81,   82,   82,
    83,   84,   84,   85,   85,   86,   87,   87,   88,   89,   89,   90,
    91,   91,   92,   93,   93,   94,   95,   95,   96,   97,   97,   98,
    99,  100,  100,  101,  102,  103,  103,  104,  105,  106,  106,  107,
   108,  109,  110,  110,  111,  112,  113,  114,  114,  115,  116,  117,
   118,  119,  120,  121,  121,  122,  123,  124,  125,  126,  127,  128,
   129,  130,  131,  132,  133,  134,  135,  136,  137,  138,  139,  140,
   141,  142,  143,  144,  145,  146,  147,  148,  149,  150,  151,  152,
   153,  155,  156,  157,  158,  159,  160,  162,  163,  164,  165,  166,
   168,  169,  170,  171,  173,  174,  175,  176,  178,  179,  180,  182,
   183,  184,  186,  187,  188,  190,  191,  193,  194,  196,  197,  198,
   200,  201,  203,  204,  206,  207,  209,  210,  212,  214,  215,  217,
   218,  220,  221,  223,  225,  226,  228,  230,  231,  233,  235,  237,
   238,  240,  242,  244,  245,  247,  249,  251,  253,  255,  256,  258,
   260,  262,  264,  266,  268,  270,  272,  274,  276,  278,  280,  282,
   284,  286,  288,  290,  292,  294,  297,  299,  301,  303,  305,  308,
   310,  312,  315,  317,  319,  322,  324,  326,  329,  331,  334,  336,
   339,  341,  344,  346,  349,  351,  354,  356,  359,  362,  364,  367,
   370,  373,  375,  378,  381,  384,  386,  389,  392,  395,  398,  401,
   404,  407,  410,  413,  416,  419,  422,  425,  428,  432,  435,  438,
   441,  444,  448,  451,  454,  458,  461,  464,  468,  471,  475,  478,
   482,  485,  489,  493,  496,  500,  504,  507,  511,  515,  519,  522,
   526,  530,  534,  538,  542,  546,  550,  554,  558,  562,  566,  571,
   575,  579,  583,  588,  592,  596,  601,  605,  610,  614,  619,  623,
   628,  633,  637,  642,  647,  651,  656,  661,  666,  671,  676,  681,
   686,  691,  696,  701,  706,  712,  717,  722,  727,  733,  738,  744,
   749,  755,  760,  766,  771,  777,  783,  789,  795,  800,  806,  812,
   818,  824,  830,  837,  843,  849,  855,  861,  868,  874,  881,  887,
   894,  900,  907,  914,  920,  927,  934,  941,  948,  955,  962,  969,
   976,  983,  991,  998, 1005, 1013, 1020, 1028, 1035, 1043, 1051, 1058,
  1066, 1074, 1082, 1090, 1098, 1106, 1114, 1123, 1131, 1139, 1148, 1156,
  1165, 1173, 1182, 1191, 1199, 1208, 1217, 1226, 1235, 1244, 1254, 1263,
  1272, 1281, 1291, 1300, 1310, 1320, 1329, 1339, 1349, 1359, 1369, 1379,
  1389, 1400, 1410, 1420, 1431, 1442, 1452, 1463, 1474, 1485, 1496, 1507,
  1518, 1529, 1540, 1552, 1563, 1575, 1586, 1598, 1610, 1622, 1633, 1646,
  1658, 1670, 1682, 1695, 1707, 1720, 1732, 1745, 1758, 1771, 1784, 1797,
  1811, 1824, 1837, 1851, 1865, 1878, 1892, 1906, 1920, 1935, 1949, 1963,
  1978, 1992, 2007, 2022, 2037, 2052, 2067, 2082, 2098, 2113, 2129, 2144,
  2160, 2176, 2192, 2208, 2225, 2241, 2258, 2274, 2291, 2308, 2325, 2342,
  2359, 2377, 2394, 2412, 2430, 2448, 2466, 2484, 2502, 2521, 2540, 2558,
  2577, 2596, 2615, 2635, 2654, 2674, 2693, 2713, 2733, 2754, 2774, 2794,
  2815, 2836, 2857, 2878, 2899, 2920, 2942, 2964, 2986, 3008, 3030, 3052,
  3075, 3097, 3120, 3143, 3166, 3190, 3213, 3237, 3261, 3285, 3309, 3334,
  3358, 3383, 3408, 3433, 3459, 3484, 3510, 3536, 3562, 3588, 3615, 3641,
  3668, 3695, 3723, 3750, 3778, 3806, 3834, 3862, 3890, 3919, 3948, 3977,
  4007, 4036, 4066, 4096, 4126, 4157, 4187, 4218, 4249, 4281, 4312, 4344,
  4376, 4409, 4441, 4474, 4507, 4540, 4574, 4607, 4641, 4676, 4710, 4745,
  4780, 4815, 4851, 4887, 4923, 4959, 4996, 5033, 5070, 5107, 5145, 5183,
  5221, 5260, 5298, 5338, 5377, 5417, 5457, 5497, 5537, 5578, 5620, 5661,
  5703, 5745, 5787, 5830, 5873, 5916, 5960, 6004, 6048, 6093, 6138, 6183,
  6229, 6275, 6321, 6368, 6415, 6462, 6510, 6558, 6606, 6655, 6704, 6754,
  6804, 6854, 6904, 6955, 7007, 7058, 7111, 7163, 7216, 7269, 7323, 7377,
  7431, 7486, 7542, 7597, 7653, 7710, 7767, 7824, 7882, 7940, 7999, 8058,
  8117, 8177, 8237, 8298, 8359, 8421, 8483, 8546, 8609, 8672, 8736, 8801,
  8866, 8931, 8997, 9064, 9131, 9198, 9266, 9334, 9403, 9473, 9543, 9613,
  9684, 9755, 9827, 9900, 9973,10047,10121,10196,10271,10347,10423,10500,
 10577,10655,10734,10813,10893,10974,11055,11136,11218,11301,11385,11469,
 11553,11639,11725,11811,11898,11986,12075,12164,12253,12344,12435,12527,
 12619,12712,12806,12901,12996,13092,13189,13286,13384,13483,13582,13683,
 13784,13885,13988,14091,14195,14300,14405,14512,14619,14727,14835,14945,
 15055,15166,15278,15391,15505,15619,15735,15851,15968,16086,16204,16324,
 16444,16566,16688,16811,16935,17060,17186,17313,17441,17570,17699,17830,
 17962,18094,18228,18362,18498,18634,18772,18910,19050,19191,19332,19475,
 19619,19764,19909,20056,20204,20354,20504,20655,20808,20961,21116,21272,
 21429,21587,21746,21907,22069,22232,22396,22561,22727,22895,23064,23234,
 23406,23579,23753,23928,24105,24283,24462,24642,24824,25008,25192,25378,
 25565,25754,25944,26136,26329,26523,26719,26916,27115,27315,27517,27720,
 27924,28130,28338,28547,28758,28970,29184,29399,29616,29835,30055,30277,
 30501,30726,30953,31181,31411,31643,31877,32112,32349,32588,32828,33071,
 33315,33561,33808,34058,34309,34563,34818,35075,35334,35594,35857,36122,
 36388,36657,36928,37200,37475,37751,38030,38311,38594,38878,39165,39455,
 39746,40039,40335,40632,40932,41235,41539,41846,42154,42466,42779,43095,
 43413,43733,44056,44381,44709,45039,45371,45706,46044,46384,46726,47071,
 47418,47768,48121,48476,48834,49194,49558,49923,50292,50663,51037,51414,
 51793,52176,52561,52949,53340,53733,54130,54529,54932,55337,55746,56157,
 56572,56989,57410,57834,58261,58691,59124,59561,60000,60443,60889,61339,
 61791,62248,62707,63170,63636,64106,64579,65056 };

static struct
	{
	ushort *Threshold;
	short codeLength0;
	short codeLength1;
	uchar next0;
	uchar next1;
	} Ladder[256] = {
#ifdef ALACRITOUS
{A+ 665,  89, 101,   1,   2},  /*   0:0.50000 */
{A+ 713,  41, 185,   3,   4},  /*   1:0.26500 */
{A+ 569, 185,  41,   5,   6},  /*   2:0.73500 */
{A+ 731,  23, 256,   7,   8},  /*   3:0.15586 */
{A+ 636, 118,  75,   9,  10},  /*   4:0.56771 */
{A+ 679,  75, 118,  11,  12},  /*   5:0.43229 */
{A+ 498, 256,  23,  13,  14},  /*   6:0.84414 */
{A+ 738,  16, 303,  15,  16},  /*   7:0.10073 */
{A+ 671,  83, 108,  17,  18},  /*   8:0.45444 */
{A+ 692,  62, 138,  19,  20},  /*   9:0.36691 */
{A+ 580, 174,  45,  21,  22},  /*  10:0.72062 */
{A+ 709,  45, 174,  23,  24},  /*  11:0.27938 */
{A+ 616, 138,  62,  25,  26},  /*  12:0.63309 */
{A+ 646, 108,  83,  27,  28},  /*  13:0.54556 */
{A+ 451, 303,  16,  29,  30},  /*  14:0.89927 */
{A+ 744,  10, 366,  31,  32},  /*  15:0.07096 */
{A+ 692,  62, 138,  33,  34},  /*  16:0.36653 */
{A+ 704,  50, 162,  35,  36},  /*  17:0.32012 */
{A+ 621, 133,  65,  37,  38},  /*  18:0.61569 */
{A+ 713,  41, 185,  39,  40},  /*  19:0.25846 */
{A+ 646, 108,  83,  41,  42},  /*  20:0.55403 */
{A+ 653, 101,  89,  43,  44},  /*  21:0.50763 */
{A+ 539, 215,  32,  45,  46},  /*  22:0.80320 */
{A+ 722,  32, 215,  47,  48},  /*  23:0.19680 */
{A+ 665,  89, 101,  49,  50},  /*  24:0.49237 */
{A+ 671,  83, 108,  51,  52},  /*  25:0.44597 */
{A+ 569, 185,  41,  53,  54},  /*  26:0.74154 */
{A+ 689,  65, 133,  55,  56},  /*  27:0.38431 */
{A+ 592, 162,  50,  57,  58},  /*  28:0.67988 */
{A+ 616, 138,  62,  59,  60},  /*  29:0.63347 */
{A+ 388, 366,  10,  61,  62},  /*  30:0.92904 */
{A+ 746,   8, 397,  63,  64},  /*  31:0.05411 */
{A+ 709,  45, 174,  65,  66},  /*  32:0.29154 */
{A+ 709,  45, 174,  67,  68},  /*  33:0.27950 */
{A+ 653, 101,  89,  69,  70},  /*  34:0.51693 */
{A+ 716,  38, 194,  71,  72},  /*  35:0.24412 */
{A+ 665,  89, 101,  73,  74},  /*  36:0.48154 */
{A+ 665,  89, 101,  75,  76},  /*  37:0.46951 */
{A+ 580, 174,  45,  77,  78},  /*  38:0.70694 */
{A+ 722,  32, 215,  79,  80},  /*  39:0.19709 */
{A+ 679,  75, 118,  81,  82},  /*  40:0.43452 */
{A+ 679,  75, 118,  83,  84},  /*  41:0.42249 */
{A+ 616, 138,  62,  85,  86},  /*  42:0.65992 */
{A+ 689,  65, 133,  87,  88},  /*  43:0.38710 */
{A+ 621, 133,  65,  89,  90},  /*  44:0.62453 */
{A+ 621, 133,  65,  91,  92},  /*  45:0.61250 */
{A+ 498, 256,  23,  93,  94},  /*  46:0.84992 */
{A+ 731,  23, 256,  95,  96},  /*  47:0.15008 */
{A+ 689,  65, 133,  97,  98},  /*  48:0.38750 */
{A+ 689,  65, 133,  99, 100},  /*  49:0.37547 */
{A+ 621, 133,  65, 101, 102},  /*  50:0.61290 */
{A+ 692,  62, 138, 103, 104},  /*  51:0.34008 */
{A+ 636, 118,  75, 105, 106},  /*  52:0.57751 */
{A+ 636, 118,  75, 107, 108},  /*  53:0.56548 */
{A+ 539, 215,  32, 109, 110},  /*  54:0.80291 */
{A+ 709,  45, 174, 111, 112},  /*  55:0.29306 */
{A+ 653, 101,  89, 113, 114},  /*  56:0.53049 */
{A+ 653, 101,  89, 115, 116},  /*  57:0.51846 */
{A+ 560, 194,  38, 117, 118},  /*  58:0.75588 */
{A+ 665,  89, 101, 119, 120},  /*  59:0.48307 */
{A+ 580, 174,  45, 121, 122},  /*  60:0.72050 */
{A+ 580, 174,  45, 123, 124},  /*  61:0.70846 */
{A+ 357, 397,   8, 125, 126},  /*  62:0.94589 */
{A+ 748,   6, 436, 151, 173},  /*  63:0.04441 */
{A+ 721,  33, 211, 176, 184},  /*  64:0.22369 */
{A+ 716,  38, 194, 177, 184},  /*  65:0.23927 */
{A+ 679,  75, 118, 186, 190},  /*  66:0.41855 */
{A+ 716,  38, 194, 177, 184},  /*  67:0.22939 */
{A+ 679,  75, 118, 185, 190},  /*  68:0.40868 */
{A+ 679,  75, 118, 186, 190},  /*  69:0.42425 */
{A+ 621, 133,  65, 191, 196},  /*  70:0.60354 */
{A+ 721,  33, 211, 174, 183},  /*  71:0.20035 */
{A+ 689,  65, 133, 184, 189},  /*  72:0.37964 */
{A+ 689,  65, 133, 185, 189},  /*  73:0.39521 */
{A+ 636, 118,  75, 191, 195},  /*  74:0.57450 */
{A+ 689,  65, 133, 185, 189},  /*  75:0.38533 */
{A+ 636, 118,  75, 190, 195},  /*  76:0.56462 */
{A+ 636, 118,  75, 191, 195},  /*  77:0.58020 */
{A+ 560, 194,  38, 197, 204},  /*  78:0.75948 */
{A+ 731,  23, 256, 171, 181},  /*  79:0.16176 */
{A+ 692,  62, 138, 183, 188},  /*  80:0.34104 */
{A+ 692,  62, 138, 183, 188},  /*  81:0.35662 */
{A+ 653, 101,  89, 190, 194},  /*  82:0.53590 */
{A+ 692,  62, 138, 183, 188},  /*  83:0.34674 */
{A+ 653, 101,  89, 189, 193},  /*  84:0.52603 */
{A+ 646, 108,  83, 190, 194},  /*  85:0.54160 */
{A+ 580, 174,  45, 195, 201},  /*  86:0.72089 */
{A+ 704,  50, 162, 182, 187},  /*  87:0.31770 */
{A+ 665,  89, 101, 188, 192},  /*  88:0.49698 */
{A+ 653, 101,  89, 189, 193},  /*  89:0.51256 */
{A+ 592, 162,  50, 194, 200},  /*  90:0.69185 */
{A+ 653, 101,  89, 189, 193},  /*  91:0.50268 */
{A+ 592, 162,  50, 194, 199},  /*  92:0.68197 */
{A+ 592, 162,  50, 194, 200},  /*  93:0.69754 */
{A+ 459, 295,  17, 202, 214},  /*  94:0.87683 */
{A+ 737,  17, 295, 167, 179},  /*  95:0.12317 */
{A+ 704,  50, 162, 181, 187},  /*  96:0.30246 */
{A+ 704,  50, 162, 182, 187},  /*  97:0.31803 */
{A+ 665,  89, 101, 188, 192},  /*  98:0.49732 */
{A+ 704,  50, 162, 181, 187},  /*  99:0.30815 */
{A+ 665,  89, 101, 188, 192},  /* 100:0.48744 */
{A+ 653, 101,  89, 189, 193},  /* 101:0.50302 */
{A+ 592, 162,  50, 194, 199},  /* 102:0.68230 */
{A+ 709,  45, 174, 180, 186},  /* 103:0.27911 */
{A+ 671,  83, 108, 187, 191},  /* 104:0.45840 */
{A+ 665,  89, 101, 188, 192},  /* 105:0.47397 */
{A+ 616, 138,  62, 193, 198},  /* 106:0.65326 */
{A+ 665,  89, 101, 187, 191},  /* 107:0.46410 */
{A+ 616, 138,  62, 193, 198},  /* 108:0.64338 */
{A+ 616, 138,  62, 193, 198},  /* 109:0.65896 */
{A+ 498, 256,  23, 200, 210},  /* 110:0.83824 */
{A+ 716,  38, 194, 177, 184},  /* 111:0.24052 */
{A+ 679,  75, 118, 186, 190},  /* 112:0.41980 */
{A+ 679,  75, 118, 186, 191},  /* 113:0.43538 */
{A+ 621, 133,  65, 192, 196},  /* 114:0.61467 */
{A+ 679,  75, 118, 186, 190},  /* 115:0.42550 */
{A+ 621, 133,  65, 192, 196},  /* 116:0.60479 */
{A+ 621, 133,  65, 192, 197},  /* 117:0.62036 */
{A+ 543, 211,  33, 198, 207},  /* 118:0.79965 */
{A+ 689,  65, 133, 185, 190},  /* 119:0.39646 */
{A+ 636, 118,  75, 191, 195},  /* 120:0.57575 */
{A+ 636, 118,  75, 191, 196},  /* 121:0.59132 */
{A+ 560, 194,  38, 197, 204},  /* 122:0.77061 */
{A+ 636, 118,  75, 191, 195},  /* 123:0.58145 */
{A+ 560, 194,  38, 197, 204},  /* 124:0.76073 */
{A+ 543, 211,  33, 197, 205},  /* 125:0.77631 */
{A+ 318, 436,   6, 208, 230},  /* 126:0.95559 */
{A+ 753,   1, 716, 127, 160},  /* 127:0.00802 */
{A+ 753,   1, 716, 127, 161},  /* 128:0.00856 */
{A+ 752,   2, 606, 128, 161},  /* 129:0.00914 */
{A+ 752,   2, 606, 129, 161},  /* 130:0.00975 */
{A+ 752,   2, 606, 130, 161},  /* 131:0.01041 */
{A+ 752,   2, 606, 131, 161},  /* 132:0.01111 */
{A+ 752,   2, 606, 132, 161},  /* 133:0.01186 */
{A+ 752,   2, 606, 133, 161},  /* 134:0.01265 */
{A+ 752,   2, 606, 134, 161},  /* 135:0.01351 */
{A+ 752,   2, 606, 135, 162},  /* 136:0.01441 */
{A+ 751,   3, 538, 136, 162},  /* 137:0.01538 */
{A+ 751,   3, 538, 137, 162},  /* 138:0.01642 */
{A+ 751,   3, 538, 138, 162},  /* 139:0.01752 */
{A+ 751,   3, 538, 139, 162},  /* 140:0.01870 */
{A+ 751,   3, 538, 140, 163},  /* 141:0.01996 */
{A+ 751,   3, 538, 141, 163},  /* 142:0.02130 */
{A+ 751,   3, 538, 142, 163},  /* 143:0.02273 */
{A+ 750,   4, 496, 143, 163},  /* 144:0.02426 */
{A+ 750,   4, 496, 144, 164},  /* 145:0.02589 */
{A+ 750,   4, 496, 145, 164},  /* 146:0.02763 */
{A+ 749,   5, 462, 146, 164},  /* 147:0.02949 */
{A+ 749,   5, 462, 147, 165},  /* 148:0.03147 */
{A+ 749,   5, 462, 148, 165},  /* 149:0.03359 */
{A+ 749,   5, 462, 149, 165},  /* 150:0.03584 */
{A+ 748,   6, 436, 150, 166},  /* 151:0.03825 */
{A+ 748,   6, 436, 151, 166},  /* 152:0.04083 */
{A+ 748,   6, 436, 152, 166},  /* 153:0.04357 */
{A+ 747,   7, 415, 153, 167},  /* 154:0.04650 */
{A+ 747,   7, 415, 154, 167},  /* 155:0.04963 */
{A+ 746,   8, 397, 155, 168},  /* 156:0.05296 */
{A+ 745,   9, 380, 156, 168},  /* 157:0.05653 */
{A+ 745,   9, 380, 157, 169},  /* 158:0.06033 */
{A+ 745,   9, 380, 158, 169},  /* 159:0.06438 */
{A+ 744,  10, 366, 159, 169},  /* 160:0.06871 */
{A+ 743,  11, 353, 160, 170},  /* 161:0.07333 */
{A+ 743,  11, 353, 161, 171},  /* 162:0.07826 */
{A+ 741,  13, 330, 162, 171},  /* 163:0.08352 */
{A+ 741,  13, 330, 163, 172},  /* 164:0.08914 */
{A+ 741,  13, 330, 164, 172},  /* 165:0.09513 */
{A+ 738,  16, 303, 165, 173},  /* 166:0.10153 */
{A+ 738,  16, 303, 166, 173},  /* 167:0.10836 */
{A+ 737,  17, 295, 167, 174},  /* 168:0.11564 */
{A+ 737,  17, 295, 168, 175},  /* 169:0.12342 */
{A+ 736,  18, 288, 169, 175},  /* 170:0.13171 */
{A+ 732,  22, 262, 170, 176},  /* 171:0.14057 */
{A+ 731,  23, 256, 171, 177},  /* 172:0.15002 */
{A+ 731,  23, 256, 172, 177},  /* 173:0.16011 */
{A+ 727,  27, 236, 173, 178},  /* 174:0.17087 */
{A+ 727,  27, 236, 174, 179},  /* 175:0.18236 */
{A+ 722,  32, 215, 175, 180},  /* 176:0.19462 */
{A+ 721,  33, 211, 176, 180},  /* 177:0.20771 */
{A+ 721,  33, 211, 177, 181},  /* 178:0.22167 */
{A+ 716,  38, 194, 178, 182},  /* 179:0.23658 */
{A+ 713,  41, 185, 179, 183},  /* 180:0.25249 */
{A+ 709,  45, 174, 180, 183},  /* 181:0.26946 */
{A+ 709,  45, 174, 181, 184},  /* 182:0.28758 */
{A+ 704,  50, 162, 182, 185},  /* 183:0.30691 */
{A+ 704,  50, 162, 183, 186},  /* 184:0.32755 */
{A+ 692,  62, 138, 184, 187},  /* 185:0.34957 */
{A+ 692,  62, 138, 185, 188},  /* 186:0.37308 */
{A+ 689,  65, 133, 186, 188},  /* 187:0.39816 */
{A+ 679,  75, 118, 187, 189},  /* 188:0.42493 */
{A+ 671,  83, 108, 188, 190},  /* 189:0.45350 */
{A+ 665,  89, 101, 189, 191},  /* 190:0.48399 */
{A+ 653, 101,  89, 190, 192},  /* 191:0.51601 */
{A+ 646, 108,  83, 191, 193},  /* 192:0.54650 */
{A+ 636, 118,  75, 192, 194},  /* 193:0.57507 */
{A+ 621, 133,  65, 193, 195},  /* 194:0.60184 */
{A+ 616, 138,  62, 193, 196},  /* 195:0.62692 */
{A+ 616, 138,  62, 194, 197},  /* 196:0.65043 */
{A+ 592, 162,  50, 195, 198},  /* 197:0.67245 */
{A+ 592, 162,  50, 196, 199},  /* 198:0.69309 */
{A+ 580, 174,  45, 197, 200},  /* 199:0.71242 */
{A+ 580, 174,  45, 198, 201},  /* 200:0.73054 */
{A+ 569, 185,  41, 198, 202},  /* 201:0.74751 */
{A+ 560, 194,  38, 199, 203},  /* 202:0.76342 */
{A+ 543, 211,  33, 200, 204},  /* 203:0.77833 */
{A+ 543, 211,  33, 201, 205},  /* 204:0.79229 */
{A+ 539, 215,  32, 201, 206},  /* 205:0.80538 */
{A+ 518, 236,  27, 202, 207},  /* 206:0.81764 */
{A+ 518, 236,  27, 203, 208},  /* 207:0.82913 */
{A+ 498, 256,  23, 204, 209},  /* 208:0.83989 */
{A+ 498, 256,  23, 204, 210},  /* 209:0.84998 */
{A+ 492, 262,  22, 205, 211},  /* 210:0.85943 */
{A+ 466, 288,  18, 206, 212},  /* 211:0.86829 */
{A+ 459, 295,  17, 206, 213},  /* 212:0.87658 */
{A+ 459, 295,  17, 207, 214},  /* 213:0.88436 */
{A+ 451, 303,  16, 208, 215},  /* 214:0.89164 */
{A+ 451, 303,  16, 208, 216},  /* 215:0.89847 */
{A+ 424, 330,  13, 209, 217},  /* 216:0.90487 */
{A+ 424, 330,  13, 209, 218},  /* 217:0.91086 */
{A+ 424, 330,  13, 210, 219},  /* 218:0.91648 */
{A+ 401, 353,  11, 210, 220},  /* 219:0.92174 */
{A+ 401, 353,  11, 211, 221},  /* 220:0.92667 */
{A+ 388, 366,  10, 212, 222},  /* 221:0.93129 */
{A+ 374, 380,   9, 212, 223},  /* 222:0.93562 */
{A+ 374, 380,   9, 212, 224},  /* 223:0.93967 */
{A+ 374, 380,   9, 213, 225},  /* 224:0.94347 */
{A+ 357, 397,   8, 213, 226},  /* 225:0.94704 */
{A+ 339, 415,   7, 214, 227},  /* 226:0.95037 */
{A+ 339, 415,   7, 214, 228},  /* 227:0.95350 */
{A+ 318, 436,   6, 215, 229},  /* 228:0.95643 */
{A+ 318, 436,   6, 215, 230},  /* 229:0.95917 */
{A+ 318, 436,   6, 215, 231},  /* 230:0.96175 */
{A+ 292, 462,   5, 216, 232},  /* 231:0.96416 */
{A+ 292, 462,   5, 216, 233},  /* 232:0.96641 */
{A+ 292, 462,   5, 216, 234},  /* 233:0.96853 */
{A+ 292, 462,   5, 217, 235},  /* 234:0.97051 */
{A+ 258, 496,   4, 217, 236},  /* 235:0.97237 */
{A+ 258, 496,   4, 217, 237},  /* 236:0.97411 */
{A+ 258, 496,   4, 218, 238},  /* 237:0.97574 */
{A+ 216, 538,   3, 218, 239},  /* 238:0.97727 */
{A+ 216, 538,   3, 218, 240},  /* 239:0.97870 */
{A+ 216, 538,   3, 218, 241},  /* 240:0.98004 */
{A+ 216, 538,   3, 219, 242},  /* 241:0.98130 */
{A+ 216, 538,   3, 219, 243},  /* 242:0.98248 */
{A+ 216, 538,   3, 219, 244},  /* 243:0.98358 */
{A+ 216, 538,   3, 219, 245},  /* 244:0.98462 */
{A+ 148, 606,   2, 219, 246},  /* 245:0.98559 */
{A+ 148, 606,   2, 220, 247},  /* 246:0.98649 */
{A+ 148, 606,   2, 220, 248},  /* 247:0.98735 */
{A+ 148, 606,   2, 220, 249},  /* 248:0.98814 */
{A+ 148, 606,   2, 220, 250},  /* 249:0.98889 */
{A+ 148, 606,   2, 220, 251},  /* 250:0.98959 */
{A+ 148, 606,   2, 220, 252},  /* 251:0.99025 */
{A+ 148, 606,   2, 220, 253},  /* 252:0.99086 */
{A+  38, 716,   1, 220, 254},  /* 253:0.99144 */
{A+  38, 716,   1, 221, 254}}; /* 254:0.99198 */
#else
{A+ 665,  89, 101,   1,   2},  /*   0:0.50000 */
{A+ 709,  45, 174,   3,   4},  /*   1:0.29268 */
{A+ 592, 162,  50,   5,   6},  /*   2:0.68268 */
{A+ 741,  13, 330,   7,   8},  /*   3:0.08284 */
{A+ 679,  75, 118,   9,  10},  /*   4:0.42384 */
{A+ 646, 108,  83,  11,  12},  /*   5:0.54661 */
{A+ 459, 295,  17,  13,  14},  /*   6:0.88761 */
{A+ 751,   3, 538,  15,  16},  /*   7:0.02071 */
{A+ 738,  16, 303,  17,  18},  /*   8:0.10994 */
{A+ 709,  45, 174,  19,  20},  /*   9:0.26719 */
{A+ 636, 118,  75,  21,  22},  /*  10:0.55919 */
{A+ 679,  75, 118,  23,  24},  /*  11:0.40618 */
{A+ 592, 162,  50,  25,  26},  /*  12:0.69818 */
{A+ 498, 256,  23,  27,  28},  /*  13:0.84925 */
{A+ 258, 496,   4,  29,  30},  /*  14:0.97190 */
{A+ 753,   1, 716,  31,  32},  /*  15:0.00518 */
{A+ 750,   4, 496,  33,  34},  /*  16:0.02480 */
{A+ 750,   4, 496,  35,  36},  /*  17:0.02748 */
{A+ 731,  23, 256,  37,  38},  /*  18:0.14519 */
{A+ 736,  18, 288,  39,  40},  /*  19:0.12503 */
{A+ 692,  62, 138,  41,  42},  /*  20:0.36803 */
{A+ 671,  83, 108,  43,  44},  /*  21:0.45072 */
{A+ 592, 162,  50,  45,  46},  /*  22:0.69372 */
{A+ 709,  45, 174,  47,  48},  /*  23:0.28022 */
{A+ 653, 101,  89,  49,  50},  /*  24:0.52322 */
{A+ 636, 118,  75,  51,  52},  /*  25:0.59695 */
{A+ 498, 256,  23,  53,  54},  /*  26:0.83995 */
{A+ 543, 211,  33,  55,  56},  /*  27:0.79202 */
{A+ 318, 436,   6,  57,  58},  /*  28:0.96231 */
{A+ 292, 462,   5,  59,  60},  /*  29:0.96602 */
{A+  38, 716,   1,  61,  62},  /*  30:0.99298 */
{A+ 753,   1, 716,  63,  64},  /*  31:0.00129 */
{A+ 753,   1, 716,  65,  66},  /*  32:0.00622 */
{A+ 753,   1, 716,  67,  68},  /*  33:0.00620 */
{A+ 749,   5, 462,  69,  70},  /*  34:0.03070 */
{A+ 753,   1, 716,  71,  72},  /*  35:0.00687 */
{A+ 749,   5, 462,  73,  74},  /*  36:0.03337 */
{A+ 751,   3, 538,  75,  76},  /*  37:0.01830 */
{A+ 721,  33, 211,  77,  78},  /*  38:0.21230 */
{A+ 749,   5, 462,  79,  80},  /*  39:0.03126 */
{A+ 731,  23, 256,  81,  82},  /*  40:0.16604 */
{A+ 713,  41, 185,  83,  84},  /*  41:0.25851 */
{A+ 671,  83, 108,  85,  86},  /*  42:0.45251 */
{A+ 692,  62, 138,  87,  88},  /*  43:0.35054 */
{A+ 646, 108,  83,  89,  90},  /*  44:0.54454 */
{A+ 621, 133,  65,  91,  92},  /*  45:0.61390 */
{A+ 518, 236,  27,  93,  94},  /*  46:0.80790 */
{A+ 731,  23, 256,  95,  96},  /*  47:0.16365 */
{A+ 692,  62, 138,  97,  98},  /*  48:0.35765 */
{A+ 679,  75, 118,  99, 100},  /*  49:0.42785 */
{A+ 621, 133,  65, 101, 102},  /*  50:0.62185 */
{A+ 653, 101,  89, 103, 104},  /*  51:0.50288 */
{A+ 592, 162,  50, 105, 106},  /*  52:0.69688 */
{A+ 543, 211,  33, 107, 108},  /*  53:0.77779 */
{A+ 258, 496,   4, 109, 110},  /*  54:0.97179 */
{A+ 580, 174,  45, 111, 112},  /*  55:0.71961 */
{A+ 424, 330,  13, 113, 114},  /*  56:0.91361 */
{A+ 339, 415,   7, 115, 116},  /*  57:0.95238 */
{A+ 148, 606,   2, 117, 118},  /*  58:0.99058 */
{A+ 318, 436,   6, 119, 120},  /*  59:0.95818 */
{A+  38, 716,   1, 121, 122},  /*  60:0.99151 */
{A+  38, 716,   1, 123, 124},  /*  61:0.99194 */
{A+  38, 716,   1, 125, 126},  /*  62:0.99824 */
{A+ 753,   1, 716, 127, 130},  /*  63:0.00032 */
{A+ 753,   1, 716, 128, 131},  /*  64:0.00234 */
{A+ 753,   1, 716, 128, 131},  /*  65:0.00155 */
{A+ 753,   1, 716, 130, 134},  /*  66:0.00726 */
{A+ 753,   1, 716, 128, 131},  /*  67:0.00155 */
{A+ 753,   1, 716, 130, 134},  /*  68:0.00724 */
{A+ 753,   1, 716, 130, 134},  /*  69:0.00768 */
{A+ 748,   6, 436, 135, 145},  /*  70:0.03857 */
{A+ 753,   1, 716, 128, 131},  /*  71:0.00172 */
{A+ 753,   1, 716, 130, 134},  /*  72:0.00791 */
{A+ 753,   1, 716, 130, 134},  /*  73:0.00834 */
{A+ 748,   6, 436, 135, 145},  /*  74:0.04121 */
{A+ 753,   1, 716, 129, 133},  /*  75:0.00458 */
{A+ 751,   3, 538, 133, 140},  /*  76:0.02241 */
{A+ 737,  17, 295, 145, 159},  /*  77:0.12055 */
{A+ 713,  41, 185, 165, 174},  /*  78:0.26555 */
{A+ 753,   1, 716, 130, 134},  /*  79:0.00781 */
{A+ 748,   6, 436, 135, 145},  /*  80:0.03912 */
{A+ 745,   9, 380, 137, 150},  /*  81:0.06613 */
{A+ 721,  33, 211, 159, 169},  /*  82:0.21113 */
{A+ 727,  27, 236, 154, 165},  /*  83:0.16986 */
{A+ 704,  50, 162, 170, 178},  /*  84:0.31486 */
{A+ 689,  65, 133, 176, 184},  /*  85:0.37738 */
{A+ 653, 101,  89, 188, 196},  /*  86:0.52238 */
{A+ 709,  45, 174, 166, 175},  /*  87:0.27141 */
{A+ 679,  75, 118, 179, 187},  /*  88:0.41641 */
{A+ 665,  89, 101, 184, 192},  /*  89:0.47511 */
{A+ 621, 133,  65, 197, 205},  /*  90:0.62011 */
{A+ 646, 108,  83, 191, 199},  /*  91:0.55049 */
{A+ 592, 162,  50, 203, 212},  /*  92:0.69549 */
{A+ 560, 194,  38, 209, 219},  /*  93:0.76080 */
{A+ 424, 330,  13, 226, 242},  /*  94:0.90580 */
{A+ 745,   9, 380, 137, 150},  /*  95:0.06428 */
{A+ 721,  33, 211, 159, 169},  /*  96:0.20928 */
{A+ 709,  45, 174, 166, 175},  /*  97:0.27741 */
{A+ 679,  75, 118, 180, 188},  /*  98:0.42241 */
{A+ 692,  62, 138, 173, 182},  /*  99:0.34947 */
{A+ 665,  89, 101, 186, 194},  /* 100:0.49447 */
{A+ 636, 118,  75, 192, 200},  /* 101:0.55724 */
{A+ 592, 162,  50, 204, 213},  /* 102:0.70224 */
{A+ 679,  75, 118, 181, 189},  /* 103:0.43455 */
{A+ 636, 118,  75, 193, 201},  /* 104:0.57955 */
{A+ 616, 138,  62, 198, 206},  /* 105:0.63670 */
{A+ 543, 211,  33, 212, 221},  /* 106:0.78170 */
{A+ 580, 174,  45, 206, 215},  /* 107:0.72649 */
{A+ 466, 288,  18, 221, 234},  /* 108:0.87149 */
{A+ 292, 462,   5, 238, 247},  /* 109:0.96591 */
{A+  38, 716,   1, 247, 251},  /* 110:0.99295 */
{A+ 616, 138,  62, 200, 208},  /* 111:0.66176 */
{A+ 539, 215,  32, 214, 224},  /* 112:0.80676 */
{A+ 459, 295,  17, 223, 237},  /* 113:0.88661 */
{A+ 216, 538,   3, 241, 249},  /* 114:0.97840 */
{A+ 374, 380,   9, 232, 245},  /* 115:0.94033 */
{A+ 148, 606,   2, 245, 250},  /* 116:0.98809 */
{A+ 148, 606,   2, 245, 250},  /* 117:0.98813 */
{A+  38, 716,   1, 250, 253},  /* 118:0.99764 */
{A+ 339, 415,   7, 234, 245},  /* 119:0.94829 */
{A+ 148, 606,   2, 245, 250},  /* 120:0.98955 */
{A+ 148, 606,   2, 246, 251},  /* 121:0.99047 */
{A+  38, 716,   1, 250, 253},  /* 122:0.99788 */
{A+ 148, 606,   2, 246, 251},  /* 123:0.99090 */
{A+  38, 716,   1, 250, 253},  /* 124:0.99798 */
{A+  38, 716,   1, 249, 252},  /* 125:0.99720 */
{A+  38, 716,   1, 251, 254},  /* 126:0.99956 */
{A+ 753,   1, 716, 127, 129},  /* 127:0.00004 */
{A+ 753,   1, 716, 127, 130},  /* 128:0.00034 */
{A+ 753,   1, 716, 128, 130},  /* 129:0.00094 */
{A+ 753,   1, 716, 128, 131},  /* 130:0.00184 */
{A+ 753,   1, 716, 129, 132},  /* 131:0.00305 */
{A+ 753,   1, 716, 129, 133},  /* 132:0.00455 */
{A+ 753,   1, 716, 130, 134},  /* 133:0.00635 */
{A+ 753,   1, 716, 130, 135},  /* 134:0.00845 */
{A+ 752,   2, 606, 131, 136},  /* 135:0.01084 */
{A+ 752,   2, 606, 131, 137},  /* 136:0.01353 */
{A+ 751,   3, 538, 132, 138},  /* 137:0.01651 */
{A+ 751,   3, 538, 132, 139},  /* 138:0.01978 */
{A+ 750,   4, 496, 133, 141},  /* 139:0.02335 */
{A+ 750,   4, 496, 133, 141},  /* 140:0.02720 */
{A+ 749,   5, 462, 134, 143},  /* 141:0.03133 */
{A+ 749,   5, 462, 134, 144},  /* 142:0.03575 */
{A+ 748,   6, 436, 132, 145},  /* 143:0.04044 */
{A+ 748,   6, 436, 134, 146},  /* 144:0.04542 */
{A+ 747,   7, 415, 136, 147},  /* 145:0.05066 */
{A+ 745,   9, 380, 139, 148},  /* 146:0.05618 */
{A+ 745,   9, 380, 140, 149},  /* 147:0.06196 */
{A+ 744,  10, 366, 142, 150},  /* 148:0.06801 */
{A+ 743,  11, 353, 143, 151},  /* 149:0.07432 */
{A+ 741,  13, 330, 145, 152},  /* 150:0.08089 */
{A+ 741,  13, 330, 146, 153},  /* 151:0.08771 */
{A+ 741,  13, 330, 147, 154},  /* 152:0.09477 */
{A+ 738,  16, 303, 148, 155},  /* 153:0.10208 */
{A+ 738,  16, 303, 149, 156},  /* 154:0.10963 */
{A+ 737,  17, 295, 151, 157},  /* 155:0.11742 */
{A+ 736,  18, 288, 152, 158},  /* 156:0.12543 */
{A+ 732,  22, 262, 153, 159},  /* 157:0.13367 */
{A+ 732,  22, 262, 154, 160},  /* 158:0.14213 */
{A+ 731,  23, 256, 155, 161},  /* 159:0.15081 */
{A+ 731,  23, 256, 156, 162},  /* 160:0.15970 */
{A+ 727,  27, 236, 158, 163},  /* 161:0.16879 */
{A+ 727,  27, 236, 159, 164},  /* 162:0.17808 */
{A+ 727,  27, 236, 160, 165},  /* 163:0.18757 */
{A+ 722,  32, 215, 161, 166},  /* 164:0.19724 */
{A+ 721,  33, 211, 162, 167},  /* 165:0.20710 */
{A+ 721,  33, 211, 163, 168},  /* 166:0.21713 */
{A+ 716,  38, 194, 164, 169},  /* 167:0.22734 */
{A+ 716,  38, 194, 165, 170},  /* 168:0.23771 */
{A+ 716,  38, 194, 166, 171},  /* 169:0.24823 */
{A+ 713,  41, 185, 167, 172},  /* 170:0.25891 */
{A+ 709,  45, 174, 168, 173},  /* 171:0.26973 */
{A+ 709,  45, 174, 169, 174},  /* 172:0.28069 */
{A+ 709,  45, 174, 170, 175},  /* 173:0.29179 */
{A+ 704,  50, 162, 172, 176},  /* 174:0.30300 */
{A+ 704,  50, 162, 173, 177},  /* 175:0.31434 */
{A+ 704,  50, 162, 173, 178},  /* 176:0.32579 */
{A+ 692,  62, 138, 175, 179},  /* 177:0.33734 */
{A+ 692,  62, 138, 176, 180},  /* 178:0.34900 */
{A+ 692,  62, 138, 177, 181},  /* 179:0.36074 */
{A+ 692,  62, 138, 178, 182},  /* 180:0.37257 */
{A+ 689,  65, 133, 179, 183},  /* 181:0.38447 */
{A+ 689,  65, 133, 180, 184},  /* 182:0.39644 */
{A+ 679,  75, 118, 181, 185},  /* 183:0.40848 */
{A+ 679,  75, 118, 182, 186},  /* 184:0.42057 */
{A+ 679,  75, 118, 183, 187},  /* 185:0.43271 */
{A+ 671,  83, 108, 184, 188},  /* 186:0.44489 */
{A+ 671,  83, 108, 185, 189},  /* 187:0.45710 */
{A+ 665,  89, 101, 186, 190},  /* 188:0.46934 */
{A+ 665,  89, 101, 187, 191},  /* 189:0.48160 */
{A+ 665,  89, 101, 188, 192},  /* 190:0.49386 */
{A+ 653, 101,  89, 189, 193},  /* 191:0.50614 */
{A+ 653, 101,  89, 190, 194},  /* 192:0.51840 */
{A+ 653, 101,  89, 191, 195},  /* 193:0.53066 */
{A+ 646, 108,  83, 192, 196},  /* 194:0.54290 */
{A+ 646, 108,  83, 193, 197},  /* 195:0.55511 */
{A+ 636, 118,  75, 194, 198},  /* 196:0.56729 */
{A+ 636, 118,  75, 195, 199},  /* 197:0.57943 */
{A+ 636, 118,  75, 196, 200},  /* 198:0.59152 */
{A+ 621, 133,  65, 197, 201},  /* 199:0.60356 */
{A+ 621, 133,  65, 198, 202},  /* 200:0.61553 */
{A+ 616, 138,  62, 199, 203},  /* 201:0.62743 */
{A+ 616, 138,  62, 200, 204},  /* 202:0.63926 */
{A+ 616, 138,  62, 201, 205},  /* 203:0.65100 */
{A+ 616, 138,  62, 202, 206},  /* 204:0.66266 */
{A+ 592, 162,  50, 203, 208},  /* 205:0.67421 */
{A+ 592, 162,  50, 204, 208},  /* 206:0.68566 */
{A+ 592, 162,  50, 205, 209},  /* 207:0.69700 */
{A+ 580, 174,  45, 206, 211},  /* 208:0.70821 */
{A+ 580, 174,  45, 207, 212},  /* 209:0.71931 */
{A+ 580, 174,  45, 208, 213},  /* 210:0.73027 */
{A+ 569, 185,  41, 209, 214},  /* 211:0.74109 */
{A+ 560, 194,  38, 210, 215},  /* 212:0.75177 */
{A+ 560, 194,  38, 211, 216},  /* 213:0.76229 */
{A+ 560, 194,  38, 212, 217},  /* 214:0.77266 */
{A+ 543, 211,  33, 213, 218},  /* 215:0.78287 */
{A+ 543, 211,  33, 214, 219},  /* 216:0.79290 */
{A+ 539, 215,  32, 215, 220},  /* 217:0.80276 */
{A+ 518, 236,  27, 216, 221},  /* 218:0.81243 */
{A+ 518, 236,  27, 217, 222},  /* 219:0.82192 */
{A+ 518, 236,  27, 218, 223},  /* 220:0.83121 */
{A+ 498, 256,  23, 219, 225},  /* 221:0.84030 */
{A+ 498, 256,  23, 220, 226},  /* 222:0.84919 */
{A+ 492, 262,  22, 221, 227},  /* 223:0.85787 */
{A+ 492, 262,  22, 222, 228},  /* 224:0.86633 */
{A+ 466, 288,  18, 223, 229},  /* 225:0.87457 */
{A+ 459, 295,  17, 224, 230},  /* 226:0.88258 */
{A+ 451, 303,  16, 225, 232},  /* 227:0.89037 */
{A+ 451, 303,  16, 226, 233},  /* 228:0.89792 */
{A+ 424, 330,  13, 227, 234},  /* 229:0.90523 */
{A+ 424, 330,  13, 228, 235},  /* 230:0.91229 */
{A+ 424, 330,  13, 229, 236},  /* 231:0.91911 */
{A+ 401, 353,  11, 230, 238},  /* 232:0.92568 */
{A+ 388, 366,  10, 231, 239},  /* 233:0.93199 */
{A+ 374, 380,   9, 232, 241},  /* 234:0.93804 */
{A+ 374, 380,   9, 233, 242},  /* 235:0.94382 */
{A+ 339, 415,   7, 234, 245},  /* 236:0.94934 */
{A+ 318, 436,   6, 235, 247},  /* 237:0.95458 */
{A+ 318, 436,   6, 236, 249},  /* 238:0.95956 */
{A+ 292, 462,   5, 237, 247},  /* 239:0.96425 */
{A+ 292, 462,   5, 238, 247},  /* 240:0.96867 */
{A+ 258, 496,   4, 240, 248},  /* 241:0.97280 */
{A+ 258, 496,   4, 240, 248},  /* 242:0.97665 */
{A+ 216, 538,   3, 242, 249},  /* 243:0.98022 */
{A+ 216, 538,   3, 243, 249},  /* 244:0.98349 */
{A+ 148, 606,   2, 244, 250},  /* 245:0.98647 */
{A+ 148, 606,   2, 245, 250},  /* 246:0.98916 */
{A+  38, 716,   1, 246, 251},  /* 247:0.99155 */
{A+  38, 716,   1, 247, 251},  /* 248:0.99365 */
{A+  38, 716,   1, 248, 252},  /* 249:0.99545 */
{A+  38, 716,   1, 249, 252},  /* 250:0.99695 */
{A+  38, 716,   1, 250, 253},  /* 251:0.99816 */
{A+  38, 716,   1, 251, 253},  /* 252:0.99906 */
{A+  38, 716,   1, 251, 254},  /* 253:0.99966 */
{A+  38, 716,   1, 252, 254}}; /* 254:0.99996 */
#endif

static struct
	{
	ushort		x;
	int			j;
	FILE		*external_in;
	}	d;

/* Initialize decoding. */
void decode_start(FILE *file)
	{
	d.external_in = file;
	d.j = F;
	/* Import first two bytes from external file. */
	d.x = fgetc(file);
	d.x = (d.x<<8) | fgetc(file);
	}

/* Decode a single bit. */
int	decode_bit(rung_t *rung)
	{
	/* Determine whether 0 or 1. */
	if (d.x >= Ladder[*rung].Threshold[d.j])
		{
		/* 1: */
		d.x -= Ladder[*rung].Threshold[d.j];
		d.j -= Ladder[*rung].codeLength1;
		#ifdef ALACRITOUS
		/* Update probability. */
		*rung = Ladder[*rung].next1;
		#endif
		if (d.j <= 0)
			{
			/* Import a byte. */
			d.j += F;
			d.x <<= 8;
			d.x |= fgetc(d.external_in);
			#ifndef ALACRITOUS
			/* Update probability. */
			*rung = Ladder[*rung].next1;
			#endif
			}
		return 1;
		}
	else
		{
		/* 0:  Buffer value need not change. */
		d.j -= Ladder[*rung].codeLength0;
		#ifdef ALACRITOUS
		/* Update probability */
		*rung = Ladder[*rung].next0;
		#endif
		if (d.j<=0)
			{
			/* Import a byte. */
			d.j += F;
			d.x <<= 8;
			d.x |= fgetc(d.external_in);
			#ifndef ALACRITOUS
			/* Update probability */
			*rung = Ladder[*rung].next0;
			#endif
			}
		return 0;
		}
	}

/* Perform consistency check prior to ending decoding. */
int decode_ok()
	{
	long y;

	if (d.j==F)
		y = 65536L;
	else
		y = A[d.j+F];
	y = (y*(d.j-1))/F;
	return d.x == y;
	}

/* Conclude decoding. */
void decode_end()
	{
	/* No action necessary. */
	}

static struct
	{
	ulong x_min;
	int j;
	int n;
	FILE *external_out;
	} e;

/* Initialize encoding. */
void encode_start(FILE *file)
	{
	e.n = 0;
	e.x_min = 0;
	e.j = F;
	e.external_out = file;
	}

/* Encode a single bit. */
void encode_bit(rung_t *rung, int bit)
	{
	if (bit)
		{
		/* Encode a 1 */
		e.x_min += Ladder[*rung].Threshold[e.j];
		e.j -= Ladder[*rung].codeLength1;
		#ifdef ALACRITOUS
		*rung = Ladder[*rung].next1;
		#endif
		}
	else
		{
		/* Encode a 0. */
		e.j -= Ladder[*rung].codeLength0;
		#ifdef ALACRITOUS
		*rung = Ladder[*rung].next0;
		#endif
		}
	if (e.j<=0)
		{
		/* Export */
		ulong	diff_bits;

		e.j += F;

		/* Check for bytes to be moved from active to postactive. */
		diff_bits = (e.x_min + A[e.j] - 1) ^ e.x_min;
		switch(e.n)
			{
		default: /* 2 or greater */
			if (diff_bits&0xFF000000)
				break;
			fputc(e.x_min>>24,e.external_out);
			while(--e.n > 1)
				fputc((e.x_min>>16)&0xFF,e.external_out);
		case 1:
			if (diff_bits&0x00FF0000)
				break;
			fputc((e.x_min>>16)&0xFF,e.external_out);
			e.n--;
		case 0:
			if (diff_bits&0x0000FF00)
				break;
			fputc((e.x_min>>8)&0xFF,e.external_out);
			e.n--;
			}
		e.n++;
		/* Move a byte from preactive to active. */
		if (e.n>2)
			e.x_min = (e.x_min&0xFF000000)|((e.x_min&0x0000FFFF)<< 8);
		else
			e.x_min <<= 8;
		#ifndef ALACRITOUS
		if (bit)
			*rung = Ladder[*rung].next1;
		else
			*rung = Ladder[*rung].next0;
		#endif
		}
	}

/* Conclude encoding. */
void encode_end()
	{
	long y;

	/* Consistency check. */
	if (e.j==F)
		y = 65536L;
	else
		y = A[e.j+F];
	y = (y*(e.j-1))/F;
	e.x_min += y;

	switch(e.n)
		{
	default:
		fputc((e.x_min>>24)&0xFF,e.external_out);
		while(--e.n > 1)
			fputc((e.x_min>>16)&0xFF,e.external_out);
	case 1:
		fputc((e.x_min>>16)&0xFF,e.external_out);
	case 0:
		fputc((e.x_min>>8)&0xFF,e.external_out);
		}
	fputc((e.x_min)&0xFF,e.external_out);
	}
