/*
APPENDIX D
"expand.c":  Test program for entropy coding:  decodes a file
using a one-byte model.
*/
#include <stdio.h>
#include "elscoder.h"

rung_t Context[256];

int main(int argc,char *argv[])
	{

	FILE	*in_file,*out_file;
	int		buffer;

	if (argc!=3)
	{
		fprintf(stderr,"Usage:\n\nexpand <in_file> <out_file>\n\n"
		 "Tests entropy encoder with 1-byte-context file decoding.\n");
		return 1;
	}

	if (!(in_file = fopen(argv[1],"rb")))
		{
		fprintf(stderr,"Unable to open input file.\n");
		return 1;
		}
	if (!(out_file = fopen(argv[2],"wb")))
		{
		fprintf(stderr,"Unable to open output file.\n");
		return 1;
		}

	/*
	 @	Initialize probabilities of state machine.
	 */
	for (buffer=0; buffer<256; buffer++)
		Context[buffer] = 0;

	decode_start(in_file);

	while(1)
		{
		buffer=1;
		buffer = (buffer<<1) | decode_bit(Context+buffer);
		buffer = (buffer<<1) | decode_bit(Context+buffer);
		buffer = (buffer<<1) | decode_bit(Context+buffer);
		buffer = (buffer<<1) | decode_bit(Context+buffer);
		buffer = (buffer<<1) | decode_bit(Context+buffer);
		buffer = (buffer<<1) | decode_bit(Context+buffer);
		buffer = (buffer<<1) | decode_bit(Context+buffer);
		buffer = (buffer<<1) | decode_bit(Context+buffer);
		buffer &= 0xFF;
		if ((buffer==255)&& decode_bit(Context))
			{
			if (decode_ok())
				printf("ELS decode_r consistency check succeeded.\n");
            else
				{
				fprintf(stderr,"ELS decode_r consistency check failed.\n");
				return 1;
				}
			decode_end();
			fclose(out_file);
			fclose(in_file);
			return 0;
			}
		fputc(buffer,out_file);
		}
	}
